
#include "CudaDevice.h"

CudaDevice::CudaDevice()
{
    _count = 0;

    int count = 0;
    if (cudaGetDeviceCount(&count) == cudaSuccess)
    {
        _count = count;
    }
}

void CudaDevice::SelectHigherDevice() const
{
    if (_count <= 1)
    {
        return;
    }

    int major = 0;
    int minor = 0;
    int device = 0;

    for (int i = 0; i < _count; i++)
    {
        cudaDeviceProp prop;
        cudaError_t result = cudaGetDeviceProperties(&prop, i);
        if (result != cudaSuccess)
        {
            continue;
        }

        if (prop.major > major)
        {
            device = i;
        }
        else if (prop.major == major)
        {
            if (prop.minor > minor)
            {
                device = i;
            }
        }
    }

    cudaSetDevice(device);
}

int CudaDevice::GetCount() const
{
    return _count;
}